#include "main.h"
#include "interface.h"
#include <math.h>


int atoi_perso(char *buf)
{
	int i,l,p,hexa,n,puis;
	char c;
	if (buf[0]=='0' && buf[1]=='x')
   {
		l=strlen(buf);
      hexa=0;
      for(i=l-1,p=0;i>=2;i--,p++)
      {
		    c=buf[i];
          n=0;
          if (c>='0' && c<='9')
             n=c-48;
          if (c>='a' && c<='f')
             n=c-87;
          puis=(int)pow(2,p*4);
          hexa=hexa+n*puis;
/*          printf("i=%d p=%d c=%c n=%d puiss=%d-> hexa=%d 0x%x \n",i,p,c,n,puis,hexa,hexa);*/
      }
	return hexa;
   }
   else
		return atoi(buf);

}

/*********************************************************************************/
void
on_ButSend_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
   char *buf;
	int result,i;
   int data_in[256];
   int data_out[256];


   if(SlaveIsRunning) return;

   gtk_statusbar_push( GTK_STATUSBAR(statusbar1),Statusbar_context_id,"Lancement de la trame.");

   if (trame.function==06)
   {
      /* store single setpoint */
      gtk_clist_get_text((GtkCList *)ClistMaster,0,1,&buf);
      data_in[0]=atoi_perso(buf);
   }
   if (trame.function==16)
   {
      /* store multiple setpoint */
      for(i=0;i<trame.length;i++)
      {
         gtk_clist_get_text((GtkCList *)ClistMaster,i,1,&buf);
/*         g_print("%d %s\n",i,buf);*/
         data_in[i]=atoi_perso(buf);
      }
   }
   

   TrameEmit=g_strdup_printf("(Master) Send ->");
   TrameRcve=g_strdup_printf("(Master) Recv <-");
   
   trame.device=gmbdev;
   trame.timeout=confreal.timeout;
   result=Mb_master(trame,data_in,data_out,writed,readed);
   /* return 0 if ok */
   if (result<0)
   {
      if (result==-1) buf=g_strdup_printf("Erreur de  parametrage de la fonction.");
      if (result==-2) buf=g_strdup_printf("Erreur de  crc.");
      if (result==-3) buf=g_strdup_printf("Erreur : time out  dpass.");
      if (result==-4) buf=g_strdup_printf("Erreur : Reponse incomprensible.");
    
      MessageWin=create_MessageWin (buf);
      gtk_widget_show(MessageWin);
   }
   else
      buf=g_strdup_printf("Reponse de l'esclave correcte.");

   gtk_statusbar_push( GTK_STATUSBAR(statusbar1),Statusbar_context_id,buf);

   if(!result && trame.function==07)
   {
      gtk_clist_freeze(GTK_CLIST(ClistMaster));
      buf=g_strdup_printf("%d \t0x%x",data_out[0],data_out[0]);
      gtk_clist_set_text(GTK_CLIST(ClistMaster),0,2,buf);
      gtk_clist_thaw(GTK_CLIST(ClistMaster));
   }
   if(!result && (trame.function==03 || trame.function==0x04))
   {
      gtk_clist_freeze(GTK_CLIST(ClistMaster));
      for(i=0;i<trame.length;i++)
      {
            buf=g_strdup_printf("%d  \t0x%x",data_out[i],data_out[i]);
            gtk_clist_set_text(GTK_CLIST(ClistMaster),i,2,buf);
      }      
      gtk_clist_thaw(GTK_CLIST(ClistMaster));
   }

   TrameEmit=g_strdup_printf("%s\n",TrameEmit);
   TrameRcve=g_strdup_printf("%s\n",TrameRcve);
   gtk_text_insert (GTK_TEXT (TextConsole), NULL, NULL, NULL,TrameEmit, -1);
   gtk_text_insert (GTK_TEXT (TextConsole), NULL, NULL, NULL,TrameRcve, -1);
   gtk_text_insert (GTK_TEXT (TextConsole), NULL, NULL, NULL,"\n", -1);

}


/*********************************************************************************/
void
on_ButEffacer_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
   gtk_text_backward_delete(GTK_TEXT (TextConsole),
      gtk_text_get_point(GTK_TEXT (TextConsole))
   );
}


/*********************************************************************************/
void
on_ButConf_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
   if (SlaveIsRunning) return;
   ConfigPort = create_ConfigPort ();
   gtk_widget_show (ConfigPort);
}


/*********************************************************************************/
void
on_ButAbout_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  about1 = create_about1 ();
  gtk_widget_show (about1);
}


/*********************************************************************************/
void
on_ButConfOk_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{

   gtk_widget_hide (ConfigPort);
   confreal=conftemp;

   /*close device & open with new parameters */
   Mb_close_device(gmbdev);
   gmbdev=Mb_open_device(confreal.port,confreal.speed,confreal.parity,confreal.databit,confreal.stop);
   gtk_statusbar_push( GTK_STATUSBAR(statusbar1),Statusbar_context_id,"Port srie configur.");

/*   g_print("\n----------------------------\n");
   g_print("OK nouvelle conf :\n");
   g_print("port          %s\n",confreal.port);
   g_print("vitesse       %d\n",confreal.speed);
   g_print("bit de donnee %d\n",confreal.databit);
   g_print("bit de stop   %d\n",confreal.stop);
   g_print("parit        %d\n",confreal.parity);
   g_print("timeout       %d\n",confreal.timeout);
   g_print("----------------------------\n");
*/
}

/*********************************************************************************/
void on_ButConfCancel_clicked               (GtkButton       *button,
                                        gpointer         user_data)
                                        
{
   gtk_widget_hide (ConfigPort);
/*   g_print("\n----------------------------\n");
   g_print("Cancel conf courante :\n");
   g_print("port          %s\n",confreal.port);
   g_print("vitesse       %d\n",confreal.speed);
   g_print("bit de donnee %d\n",confreal.databit);
   g_print("bit de stop   %d\n",confreal.stop);
   g_print("parit        %d\n",confreal.parity);
   g_print("timeout       %d\n",confreal.timeout);
   g_print("----------------------------\n");
   */
}

/*********************************************************************************/
void
on_about1_clicked                      (GnomeDialog     *gnomedialog,
                                        gint             arg1,
                                        gpointer         user_data)
{
   gtk_widget_hide (about1);
}


/*********************************************************************************/
void
on_OptionMasterTrame_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
   
   trame.function=atoi_perso(user_data);
}


/*********************************************************************************/
void
on_SpinMasterSlaveNum_changed          (GtkEditable     *editable,
                                        gpointer         user_data)
{
   trame.slave=atoi_perso(gtk_entry_get_text(GTK_ENTRY(editable)));
}


/*********************************************************************************/
void
on_EntryMasterAdres_changed            (GtkEditable     *editable,
                                        gpointer         user_data)
{
   trame.address=atoi_perso(gtk_entry_get_text(GTK_ENTRY(editable)));
}

/*********************************************************************************/
void
on_EntryMasterLen_changed              (GtkEditable     *editable,
                                        gpointer         user_data)
{
   trame.length=atoi_perso(gtk_entry_get_text(GTK_ENTRY(editable)));
}


/*********************************************************************************/
void
on_SpinSlaveSlaveNum_changed           (GtkEditable     *editable,
                                        gpointer         user_data)
{
   Slave=atoi_perso(gtk_entry_get_text(GTK_ENTRY(editable)));
}


/*********************************************************************************/
void
on_RadioHexa_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
   if(GTK_TOGGLE_BUTTON(togglebutton)->active)
   {
      Text_HoD=1;
   }

}


/*********************************************************************************/
void
on_RadioDec_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
   if(GTK_TOGGLE_BUTTON(togglebutton)->active)
   {
      Text_HoD=0;
   }

}


/*********************************************************************************/
void
on_OptionDevice_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
   switch (atoi(user_data))
   {
      case 1:
         conftemp.port=g_strdup_printf("/dev/ttyS1");
         break;
      case 2:
         conftemp.port=g_strdup_printf("/dev/ttyS2");
         break;
      case 3:
         conftemp.port=g_strdup_printf("/dev/ttyS3");
         break;
      default:
      case 0:
         conftemp.port=g_strdup_printf("/dev/ttyS0");
         break;
   }
}


/*********************************************************************************/
void
on_EntrySpeed_changed                  (GtkEditable     *editable,
                                        gpointer         user_data)
{
   conftemp.speed=atoi_perso(gtk_entry_get_text(GTK_ENTRY(editable)));
}

/*********************************************************************************/
void
on_RadioBit7_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
   if(GTK_TOGGLE_BUTTON(togglebutton)->active)
   {
      conftemp.databit=7;
   }
   
}


/*********************************************************************************/
void on_RadioBit8_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
   if(GTK_TOGGLE_BUTTON(togglebutton)->active)
   {
      conftemp.databit=8;
   }
}


/*********************************************************************************/
void on_RadioStop1_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
   if(GTK_TOGGLE_BUTTON(togglebutton)->active)
   {
      conftemp.stop=1;
   }

}


/*********************************************************************************/
void on_RadioStop2_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
   if(GTK_TOGGLE_BUTTON(togglebutton)->active)
   {
      conftemp.stop=2;
   }

}


/*********************************************************************************/
void on_RadioParNone_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
   if(GTK_TOGGLE_BUTTON(togglebutton)->active)
   {
      conftemp.parity=0;
   }
}


/*********************************************************************************/
void on_RadioParPaire_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
   if(GTK_TOGGLE_BUTTON(togglebutton)->active)
   {
      conftemp.parity=1;
   }
}


/*********************************************************************************/
void on_RadioParImpaire_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
   if(GTK_TOGGLE_BUTTON(togglebutton)->active)
   {
      conftemp.parity=-1;
   }
}


/*********************************************************************************/
void on_SpinTimeout_changed                 (GtkEditable     *editable,
                                        gpointer         user_data)
{
   conftemp.timeout=gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON (editable));
}

/*********************************************************************************/
void on_EntryEdit_changed                   (GtkEditable     *editable,
                                        gpointer         user_data)
{
}


/*********************************************************************************/
void on_ButEditOk_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
   char *buf;
   int val;
   if (ClistMasterRow!=-1)
   {
      val=atoi_perso(gtk_entry_get_text(GTK_ENTRY(EntryEdit)));
      if (val>0xffff)
      {
         g_print("\a");
         gtk_statusbar_push( GTK_STATUSBAR(statusbar1),Statusbar_context_id,"Valeur maximale pour un mot : 65535 (0xffff).");
 
      }
      else
      {
         buf=g_strdup_printf("%d \t0x%x",val,val);
         gtk_clist_set_text(GTK_CLIST(ClistMaster),ClistMasterRow,1,buf);
         gtk_clist_unselect_row(GTK_CLIST(ClistMaster),ClistMasterRow,1);
      }
   }
   if (ClistSlaveRow!=-1)
   {
      val=atoi_perso(gtk_entry_get_text(GTK_ENTRY(EntryEdit)));
      if (val>0xffff) 
      {
         g_print("\a");
         gtk_statusbar_push( GTK_STATUSBAR(statusbar1),Statusbar_context_id,"Valeur maximale pour un mot : 65535 (0xffff).");
      }
      else
      {
         Mbs_data[ClistSlaveRow]=val;
         buf=g_strdup_printf("%d \t0x%x",val,val);
         gtk_clist_set_text(GTK_CLIST(ClistSlave),ClistSlaveRow,1,buf);
         gtk_clist_unselect_row(GTK_CLIST(ClistSlave),ClistSlaveRow,1);
      }
   }
   gtk_widget_hide (EditWin);

}


/*********************************************************************************/
void on_ButEditCancel_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_clist_unselect_row(GTK_CLIST(ClistMaster),ClistMasterRow,1);
  gtk_clist_unselect_row(GTK_CLIST(ClistSlave),ClistSlaveRow,1);
  ClistMasterRow=-1;
  ClistSlaveRow=-1;
  gtk_widget_hide (EditWin);
}

/*********************************************************************************/
gint
on_EditWin_close                       (GnomeDialog     *gnomedialog,
                                        gpointer         user_data)
{
   gtk_widget_hide (EditWin);
   gtk_clist_unselect_row(GTK_CLIST(ClistMaster),ClistMasterRow,1);
   gtk_clist_unselect_row(GTK_CLIST(ClistSlave),ClistSlaveRow,1);
   ClistMasterRow=-1;
   ClistSlaveRow=-1;
}
                                        
/*********************************************************************************/
void on_ClistMaster_select_row              (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
   char *buf;
   int l;
   
   ClistMasterRow=row;
   ClistSlaveRow=-1;

   EditWin = create_EditWin ();
   
   gtk_clist_get_text((GtkCList *)ClistMaster,row,1,&buf);
   buf=g_strdup_printf("%d",atoi_perso(buf));
   gtk_entry_set_text(GTK_ENTRY(EntryEdit),buf);
   l=strlen(gtk_entry_get_text(GTK_ENTRY(EntryEdit)));
   gtk_entry_set_position(GTK_ENTRY(EntryEdit),l);
   gtk_entry_select_region(GTK_ENTRY(EntryEdit),0,l);

   gtk_widget_grab_focus(EntryEdit);

   gtk_widget_show (EditWin);
}

/*********************************************************************************/
void on_ClistSlave_select_row               (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)

{
   char *buf;
   int l;
   
   ClistMasterRow=-1;
   ClistSlaveRow=row;

   EditWin = create_EditWin ();

   gtk_clist_get_text((GtkCList *)ClistSlave,row,1,&buf);
   buf=g_strdup_printf("%d",atoi_perso(buf));
   gtk_entry_set_text(GTK_ENTRY(EntryEdit),buf);
   l=strlen(gtk_entry_get_text(GTK_ENTRY(EntryEdit)));
   gtk_entry_set_position(GTK_ENTRY(EntryEdit),l);
   gtk_entry_select_region(GTK_ENTRY(EntryEdit),0,l);
   
   gtk_widget_grab_focus(EntryEdit);

   gtk_widget_show (EditWin);

}
/*********************************************************************************/
void Quit                                   (GtkObject       *object,
                                        gpointer         user_data)
{
   gtk_main_quit();

}

/*********************************************************************************/
void on_ButInfoOk_clicked                   (GtkButton       *button,
                                        gpointer         user_data)

{

}


/*********************************************************************************/
void
on_CheckRunSlave_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)

{
   if(GTK_TOGGLE_BUTTON(togglebutton)->active)
   {
      SlaveIsRunning=1;
      TrameRcve=g_strdup_printf("(Slave) Recv <-");
      TrameEmit=g_strdup_printf("(Slave) Send ->");
/*      Mb_slave(gmbdev,Slave,writed,readed,end_slave);*/
      Mb_slave(gmbdev,Slave,writed,readed,end_slave);
      gtk_statusbar_push( GTK_STATUSBAR(statusbar1),Statusbar_context_id,"Lancement de la fonction esclave.");
/*      g_print("Lancement de la fonction esclave.\n");*/
      
   }
   else
   {
      Mb_slave_stop();
      SlaveIsRunning=0;
      gtk_statusbar_push( GTK_STATUSBAR(statusbar1),Statusbar_context_id,"Arret de la fonction esclave.");
      gtk_clist_thaw(GTK_CLIST(ClistSlave));
/*      g_print("Arret de la fonction esclave.\n");*/
   }
      
}



/*********************************************************************************/
gboolean
on_EditWin_key_press_event             (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)

{
	if(event->keyval==GDK_Return)
   on_ButEditOk_clicked(NULL,user_data);
}
