#include "main.h"
#include "interface.h"
#include "callbacks.h"

GtkWidget*
create_MainWin (void)
{
  GtkWidget *Win;
  GtkWidget *vbox2;
  GtkWidget *notebook1;
  GtkWidget *vbox3;
  GtkWidget *hbox8;
  GtkWidget *label13;
  GtkWidget *OptionMasterTrame;
  GtkWidget *OptionMasterTrame_menu;
  GtkWidget *glade_menuitem;
  GtkWidget *hbox9;
  GtkWidget *label12;
  GtkObject *SpinMasterSlaveNum_adj;
  GtkWidget *SpinMasterSlaveNum;
  GtkWidget *hbox11;
  GtkWidget *label15;
  GtkWidget *EntryMasterAdres;
  GtkWidget *hbox12;
  GtkWidget *label16;
  GtkWidget *EntryMasterLen;
  GtkWidget *hbox10;
  GtkWidget *scrolledwindow2;
  GtkWidget *label23;
  GtkWidget *label24;
  GtkWidget *label25;
  GtkWidget *ButSend;
  GtkWidget *label8;
  GtkWidget *vbox5;
  GtkWidget *hbox15;
  GtkWidget *label18;
  GtkObject *SpinSlaveSlaveNum_adj;
  GtkWidget *SpinSlaveSlaveNum;
  GtkWidget *label21;
  GtkWidget *scrolledwindow3;
  GtkWidget *label27;
  GtkWidget *label28;
  GtkWidget *label9;
  GtkWidget *vbox4;
  GtkWidget *scrolledwindow1;
  GtkWidget *hbox13;
  GtkWidget *ButEffacer;
  GSList *hbox13_group = NULL;
  GtkWidget *RadioHexa;
  GtkWidget *RadioDec;
  GtkWidget *label10;
  GtkWidget *hbox7;
  GtkWidget *ButConf;
  GtkWidget *ButQuit;
  GtkWidget *ButAbout;
  GtkWidget *CheckRunSlave;
  
  char *buf;
  buf = (char *) malloc(20*sizeof(char));  

  Win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (Win), "Win", Win);
  gtk_window_set_title (GTK_WINDOW (Win), _("G Modbus Control"));

  vbox2 = gtk_vbox_new (FALSE, 3);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (Win), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (Win), vbox2);
  gtk_container_set_border_width (GTK_CONTAINER (vbox2), 2);

  notebook1 = gtk_notebook_new ();
  gtk_widget_ref (notebook1);
  gtk_object_set_data_full (GTK_OBJECT (Win), "notebook1", notebook1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook1);
  gtk_box_pack_start (GTK_BOX (vbox2), notebook1, TRUE, TRUE, 0);
  gtk_widget_set_usize (notebook1, 400, -2);

  vbox3 = gtk_vbox_new (FALSE, 3);
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (Win), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox3);
  gtk_container_set_border_width (GTK_CONTAINER (vbox3), 5);

  hbox8 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox8);
  gtk_object_set_data_full (GTK_OBJECT (Win), "hbox8", hbox8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox8);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox8, TRUE, TRUE, 0);

  label13 = gtk_label_new (_("Type de trame"));
  gtk_widget_ref (label13);
  gtk_object_set_data_full (GTK_OBJECT (Win), "label13", label13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label13);
  gtk_box_pack_start (GTK_BOX (hbox8), label13, FALSE, FALSE, 0);
  gtk_widget_set_usize (label13, 180, 20);

  OptionMasterTrame = gtk_option_menu_new ();
  gtk_widget_ref (OptionMasterTrame);
  gtk_object_set_data_full (GTK_OBJECT (Win), "OptionMasterTrame", OptionMasterTrame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (OptionMasterTrame);
  gtk_box_pack_start (GTK_BOX (hbox8), OptionMasterTrame, FALSE, FALSE, 0);
  OptionMasterTrame_menu = gtk_menu_new ();

  glade_menuitem = gtk_menu_item_new_with_label (_("03 - Lecture de n mots"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (OptionMasterTrame_menu), glade_menuitem);
  gtk_signal_connect (GTK_OBJECT (glade_menuitem), "activate",
                      GTK_SIGNAL_FUNC (on_OptionMasterTrame_clicked),
                      "03");

  glade_menuitem = gtk_menu_item_new_with_label (_("04 - Lecture de n mots"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (OptionMasterTrame_menu), glade_menuitem);
  gtk_signal_connect (GTK_OBJECT (glade_menuitem), "activate",
                      GTK_SIGNAL_FUNC (on_OptionMasterTrame_clicked),
                      "04");

  glade_menuitem = gtk_menu_item_new_with_label (_("06 - Ecriture de un mot"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (OptionMasterTrame_menu), glade_menuitem);
  gtk_signal_connect (GTK_OBJECT (glade_menuitem), "activate",
                      GTK_SIGNAL_FUNC (on_OptionMasterTrame_clicked),
                      "06");

  glade_menuitem = gtk_menu_item_new_with_label (_("07 - Controle de l'esclave"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (OptionMasterTrame_menu), glade_menuitem);
  gtk_signal_connect (GTK_OBJECT (glade_menuitem), "activate",
                      GTK_SIGNAL_FUNC (on_OptionMasterTrame_clicked),
                      "07");

  glade_menuitem = gtk_menu_item_new_with_label (_("08 - Test de ligne"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (OptionMasterTrame_menu), glade_menuitem);
  gtk_signal_connect (GTK_OBJECT (glade_menuitem), "activate",
                      GTK_SIGNAL_FUNC (on_OptionMasterTrame_clicked),
                      "08");

  glade_menuitem = gtk_menu_item_new_with_label (_("16 - Ecriture de n mots"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (OptionMasterTrame_menu), glade_menuitem);
  gtk_signal_connect (GTK_OBJECT (glade_menuitem), "activate",
                      GTK_SIGNAL_FUNC (on_OptionMasterTrame_clicked),
                      "16");

  gtk_option_menu_set_menu (GTK_OPTION_MENU (OptionMasterTrame), OptionMasterTrame_menu);

  hbox9 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox9);
  gtk_object_set_data_full (GTK_OBJECT (Win), "hbox9", hbox9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox9);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox9, TRUE, TRUE, 0);

  label12 = gtk_label_new (_("N d'esclave"));
  gtk_widget_ref (label12);
  gtk_object_set_data_full (GTK_OBJECT (Win), "label12", label12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label12);
  gtk_box_pack_start (GTK_BOX (hbox9), label12, FALSE, FALSE, 0);
  gtk_widget_set_usize (label12, 180, 20);

  SpinMasterSlaveNum_adj = gtk_adjustment_new (trame.slave, 1, 255, 1, 10, 10);
  SpinMasterSlaveNum = gtk_spin_button_new (GTK_ADJUSTMENT (SpinMasterSlaveNum_adj), 1, 0);
  gtk_widget_ref (SpinMasterSlaveNum);
  gtk_object_set_data_full (GTK_OBJECT (Win), "SpinMasterSlaveNum", SpinMasterSlaveNum,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (SpinMasterSlaveNum);
  gtk_box_pack_start (GTK_BOX (hbox9), SpinMasterSlaveNum, TRUE, TRUE, 0);

  hbox11 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox11);
  gtk_object_set_data_full (GTK_OBJECT (Win), "hbox11", hbox11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox11);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox11, TRUE, TRUE, 0);

  label15 = gtk_label_new (_("Adresse de dpart"));
  gtk_widget_ref (label15);
  gtk_object_set_data_full (GTK_OBJECT (Win), "label15", label15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label15);
  gtk_box_pack_start (GTK_BOX (hbox11), label15, FALSE, FALSE, 0);
  gtk_widget_set_usize (label15, 180, 20);

  EntryMasterAdres = gtk_entry_new ();
  gtk_widget_ref (EntryMasterAdres);
  gtk_object_set_data_full (GTK_OBJECT (Win), "EntryMasterAdres", EntryMasterAdres,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EntryMasterAdres);
  gtk_box_pack_start (GTK_BOX (hbox11), EntryMasterAdres, TRUE, TRUE, 0);

  hbox12 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox12);
  gtk_object_set_data_full (GTK_OBJECT (Win), "hbox12", hbox12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox12);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox12, FALSE, FALSE, 0);

  label16 = gtk_label_new (_("Longueur"));
  gtk_widget_ref (label16);
  gtk_object_set_data_full (GTK_OBJECT (Win), "label16", label16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label16);
  gtk_box_pack_start (GTK_BOX (hbox12), label16, FALSE, FALSE, 0);
  gtk_widget_set_usize (label16, 180, -2);

  EntryMasterLen = gtk_entry_new ();
  gtk_widget_ref (EntryMasterLen);
  gtk_object_set_data_full (GTK_OBJECT (Win), "EntryMasterLen", EntryMasterLen,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EntryMasterLen);
  gtk_box_pack_start (GTK_BOX (hbox12), EntryMasterLen, TRUE, TRUE, 0);

  hbox10 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox10);
  gtk_object_set_data_full (GTK_OBJECT (Win), "hbox10", hbox10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox10);
  gtk_box_pack_start (GTK_BOX (vbox3), hbox10, TRUE, TRUE, 0);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (Win), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_box_pack_start (GTK_BOX (hbox10), scrolledwindow2, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  ClistMaster = gtk_clist_new (3);
  gtk_widget_ref (ClistMaster);
  gtk_object_set_data_full (GTK_OBJECT (Win), "ClistMaster", ClistMaster,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ClistMaster);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), ClistMaster);
  gtk_widget_set_usize (ClistMaster, -2, 164);
  gtk_clist_set_column_width (GTK_CLIST (ClistMaster), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (ClistMaster), 1, 120);
  gtk_clist_set_column_width (GTK_CLIST (ClistMaster), 2, 80);
  gtk_clist_column_titles_show (GTK_CLIST (ClistMaster));

  label23 = gtk_label_new (_("Adresse"));
  gtk_widget_ref (label23);
  gtk_object_set_data_full (GTK_OBJECT (Win), "label23", label23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label23);
  gtk_clist_set_column_widget (GTK_CLIST (ClistMaster), 0, label23);

  label24 = gtk_label_new (_("Donne envoyes"));
  gtk_widget_ref (label24);
  gtk_object_set_data_full (GTK_OBJECT (Win), "label24", label24,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label24);
  gtk_clist_set_column_widget (GTK_CLIST (ClistMaster), 1, label24);

  label25 = gtk_label_new (_("Done reus"));
  gtk_widget_ref (label25);
  gtk_object_set_data_full (GTK_OBJECT (Win), "label25", label25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label25);
  gtk_clist_set_column_widget (GTK_CLIST (ClistMaster), 2, label25);

  ButSend = gtk_button_new_with_label (_("Envoyer"));
  gtk_widget_ref (ButSend);
  gtk_object_set_data_full (GTK_OBJECT (Win), "ButSend", ButSend,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButSend);
  gtk_box_pack_start (GTK_BOX (vbox3), ButSend, FALSE, FALSE, 0);

  label8 = gtk_label_new (_("Master"));
  gtk_widget_ref (label8);
  gtk_object_set_data_full (GTK_OBJECT (Win), "label8", label8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label8);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), label8);

  vbox5 = gtk_vbox_new (FALSE, 3);
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (Win), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox5);
  gtk_container_set_border_width (GTK_CONTAINER (vbox5), 5);

  hbox15 = gtk_hbox_new (FALSE, 5);
  gtk_widget_ref (hbox15);
  gtk_object_set_data_full (GTK_OBJECT (Win), "hbox15", hbox15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox15);
  gtk_box_pack_start (GTK_BOX (vbox5), hbox15, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox15), 2);

  label18 = gtk_label_new (_("N d'esclave"));
  gtk_widget_ref (label18);
  gtk_object_set_data_full (GTK_OBJECT (Win), "label18", label18,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label18);
  gtk_box_pack_start (GTK_BOX (hbox15), label18, FALSE, FALSE, 0);
  gtk_widget_set_usize (label18, -2, 20);
  gtk_label_set_justify (GTK_LABEL (label18), GTK_JUSTIFY_RIGHT);

  SpinSlaveSlaveNum_adj = gtk_adjustment_new (Slave, 1, 255, 1, 10, 10);
  SpinSlaveSlaveNum = gtk_spin_button_new (GTK_ADJUSTMENT (SpinSlaveSlaveNum_adj), 1, 0);
  gtk_widget_ref (SpinSlaveSlaveNum);
  gtk_object_set_data_full (GTK_OBJECT (Win), "SpinSlaveSlaveNum", SpinSlaveSlaveNum,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (SpinSlaveSlaveNum);
  gtk_box_pack_start (GTK_BOX (hbox15), SpinSlaveSlaveNum, TRUE, TRUE, 0);

  CheckRunSlave = gtk_check_button_new_with_label (_("Activer"));
  gtk_widget_ref (CheckRunSlave);
  gtk_object_set_data_full (GTK_OBJECT (Win), "CheckRunSlave", CheckRunSlave,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (CheckRunSlave);
  gtk_box_pack_start (GTK_BOX (hbox15), CheckRunSlave, FALSE, FALSE, 40);
  gtk_widget_set_usize (CheckRunSlave, 100, -2);

  label21 = gtk_label_new (_("Table modbus"));
  gtk_widget_ref (label21);
  gtk_object_set_data_full (GTK_OBJECT (Win), "label21", label21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label21);
  gtk_box_pack_start (GTK_BOX (vbox5), label21, FALSE, FALSE, 0);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (Win), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_box_pack_start (GTK_BOX (vbox5), scrolledwindow3, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  ClistSlave = gtk_clist_new (2);
  gtk_widget_ref (ClistSlave);
  gtk_object_set_data_full (GTK_OBJECT (Win), "ClistSlave", ClistSlave,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ClistSlave);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), ClistSlave);
  gtk_widget_set_usize (ClistSlave, -2, 245);
  gtk_clist_set_column_width (GTK_CLIST (ClistSlave), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (ClistSlave), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (ClistSlave));

  label27 = gtk_label_new (_("Adresse"));
  gtk_widget_ref (label27);
  gtk_object_set_data_full (GTK_OBJECT (Win), "label27", label27,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label27);
  gtk_clist_set_column_widget (GTK_CLIST (ClistSlave), 0, label27);

  label28 = gtk_label_new (_("Donne"));
  gtk_widget_ref (label28);
  gtk_object_set_data_full (GTK_OBJECT (Win), "label28", label28,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label28);
  gtk_clist_set_column_widget (GTK_CLIST (ClistSlave), 1, label28);

  label9 = gtk_label_new (_("Slave"));
  gtk_widget_ref (label9);
  gtk_object_set_data_full (GTK_OBJECT (Win), "label9", label9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label9);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 1), label9);

  vbox4 = gtk_vbox_new (FALSE, 3);
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (Win), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox4);
  gtk_container_set_border_width (GTK_CONTAINER (vbox4), 3);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (Win), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox4), scrolledwindow1, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  TextConsole = gtk_text_new (NULL, NULL);
  gtk_widget_ref (TextConsole);
  gtk_object_set_data_full (GTK_OBJECT (Win), "TextConsole", TextConsole,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (TextConsole);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), TextConsole);
  gtk_widget_set_usize (TextConsole, -2, 265);

  hbox13 = gtk_hbox_new (FALSE, 20);
  gtk_widget_ref (hbox13);
  gtk_object_set_data_full (GTK_OBJECT (Win), "hbox13", hbox13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox13);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox13, TRUE, TRUE, 0);

  ButEffacer = gtk_button_new_with_label (_("Effacer"));
  gtk_widget_ref (ButEffacer);
  gtk_object_set_data_full (GTK_OBJECT (Win), "ButEffacer", ButEffacer,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButEffacer);
  gtk_box_pack_start (GTK_BOX (hbox13), ButEffacer, FALSE, FALSE, 0);
  gtk_widget_set_usize (ButEffacer, 60, -2);

  RadioHexa = gtk_radio_button_new_with_label (hbox13_group, _("Hexadecimal"));
  hbox13_group = gtk_radio_button_group (GTK_RADIO_BUTTON (RadioHexa));
  gtk_widget_ref (RadioHexa);
  gtk_object_set_data_full (GTK_OBJECT (Win), "RadioHexa", RadioHexa,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RadioHexa);
  gtk_box_pack_start (GTK_BOX (hbox13), RadioHexa, FALSE, FALSE, 0);

  RadioDec = gtk_radio_button_new_with_label (hbox13_group, _("Decimal"));
  hbox13_group = gtk_radio_button_group (GTK_RADIO_BUTTON (RadioDec));
  gtk_widget_ref (RadioDec);
  gtk_object_set_data_full (GTK_OBJECT (Win), "RadioDec", RadioDec,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RadioDec);
  gtk_box_pack_start (GTK_BOX (hbox13), RadioDec, FALSE, FALSE, 0);

  label10 = gtk_label_new (_("Console"));
  gtk_widget_ref (label10);
  gtk_object_set_data_full (GTK_OBJECT (Win), "label10", label10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label10);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 2), label10);

  hbox7 = gtk_hbox_new (FALSE, 10);
  gtk_widget_ref (hbox7);
  gtk_object_set_data_full (GTK_OBJECT (Win), "hbox7", hbox7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox7);
  gtk_box_pack_start (GTK_BOX (vbox2), hbox7, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox7), 3);

  ButConf = gtk_button_new_with_label (_("Configuration du port serie"));
  gtk_widget_ref (ButConf);
  gtk_object_set_data_full (GTK_OBJECT (Win), "ButConf", ButConf,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButConf);
  gtk_box_pack_start (GTK_BOX (hbox7), ButConf, FALSE, FALSE, 0);
  gtk_widget_set_usize (ButConf, 150, -2);

  ButQuit = gtk_button_new_with_label (_("Quitter"));
  gtk_widget_ref (ButQuit);
  gtk_object_set_data_full (GTK_OBJECT (Win), "ButQuit", ButQuit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButQuit);
  gtk_box_pack_start (GTK_BOX (hbox7), ButQuit, FALSE, FALSE, 0);
  gtk_widget_set_usize (ButQuit, 60, -2);

  ButAbout = gtk_button_new_with_label (_("A Propos"));
  gtk_widget_ref (ButAbout);
  gtk_object_set_data_full (GTK_OBJECT (Win), "ButAbout", ButAbout,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButAbout);
  gtk_box_pack_start (GTK_BOX (hbox7), ButAbout, FALSE, FALSE, 0);
  gtk_widget_set_usize (ButAbout, 60, -2);

  statusbar1 = gtk_statusbar_new ();
  gtk_widget_ref (statusbar1);
  gtk_object_set_data_full (GTK_OBJECT (Win), "statusbar1", statusbar1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (statusbar1);
  gtk_box_pack_start (GTK_BOX (vbox2), statusbar1, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (Win), "destroy",
                      GTK_SIGNAL_FUNC (Quit),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (OptionMasterTrame), "clicked",
                      GTK_SIGNAL_FUNC (on_OptionMasterTrame_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (SpinMasterSlaveNum), "changed",
                      GTK_SIGNAL_FUNC (on_SpinMasterSlaveNum_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EntryMasterAdres), "changed",
                      GTK_SIGNAL_FUNC (on_EntryMasterAdres_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EntryMasterLen), "changed",
                      GTK_SIGNAL_FUNC (on_EntryMasterLen_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ButSend), "clicked",
                      GTK_SIGNAL_FUNC (on_ButSend_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (SpinSlaveSlaveNum), "changed",
                      GTK_SIGNAL_FUNC (on_SpinSlaveSlaveNum_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ButEffacer), "clicked",
                      GTK_SIGNAL_FUNC (on_ButEffacer_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (RadioHexa), "toggled",
                      GTK_SIGNAL_FUNC (on_RadioHexa_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (RadioDec), "toggled",
                      GTK_SIGNAL_FUNC (on_RadioDec_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ButConf), "clicked",
                      GTK_SIGNAL_FUNC (on_ButConf_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ButQuit), "clicked",
                      GTK_SIGNAL_FUNC (Quit),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ButAbout), "clicked",
                      GTK_SIGNAL_FUNC (on_ButAbout_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ClistSlave), "select_row",
                      GTK_SIGNAL_FUNC (on_ClistSlave_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ClistMaster), "select_row",
                      GTK_SIGNAL_FUNC (on_ClistMaster_select_row),
                      NULL);
  
  gtk_signal_connect (GTK_OBJECT (CheckRunSlave), "toggled",
                      GTK_SIGNAL_FUNC (on_CheckRunSlave_toggled),
                      NULL);


  Statusbar_context_id = gtk_statusbar_get_context_id( GTK_STATUSBAR(statusbar1), "Information statusbar");


  /* init interface */
  switch(trame.function)
  {
     case 3:
        gtk_option_menu_set_history(GTK_OPTION_MENU(OptionMasterTrame),0);
        break;
     case 4:
        gtk_option_menu_set_history(GTK_OPTION_MENU(OptionMasterTrame),1);
        break;
     case 6:
        gtk_option_menu_set_history(GTK_OPTION_MENU(OptionMasterTrame),2);
        break;
     case 7:
        gtk_option_menu_set_history(GTK_OPTION_MENU(OptionMasterTrame),3);
        break;
     case 8:
        gtk_option_menu_set_history(GTK_OPTION_MENU(OptionMasterTrame),4);
        break;
     case 16:
        gtk_option_menu_set_history(GTK_OPTION_MENU(OptionMasterTrame),5);
        break;
     default:
  }

  g_snprintf(buf,10,"%d",trame.address);
  gtk_entry_set_text(GTK_ENTRY(EntryMasterAdres),buf);

  g_snprintf(buf,10,"%d",trame.length);
  gtk_entry_set_text(GTK_ENTRY(EntryMasterLen),buf);

  if (Text_HoD==1)
     gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (RadioHexa), TRUE);
  else
     gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (RadioDec), TRUE);

  return Win;
}

GtkWidget*
create_EditWin (void)
{
  GtkWidget *EdWin;
  GtkWidget *dialog_vbox2;
  GtkWidget *vbox6;
  GtkWidget *label29;
  GtkWidget *dialog_action_area2;
  GtkWidget *ButEditOk;
  GtkWidget *ButEditCancel;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  EdWin = gnome_dialog_new (_("Edition"), NULL);
  gtk_object_set_data (GTK_OBJECT (EdWin), "EdWin", EdWin);
  gtk_window_set_policy (GTK_WINDOW (EdWin), FALSE, FALSE, FALSE);

  dialog_vbox2 = GNOME_DIALOG (EdWin)->vbox;
  gtk_object_set_data (GTK_OBJECT (EdWin), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  vbox6 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox6);
  gtk_object_set_data_full (GTK_OBJECT (EdWin), "vbox6", vbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox6);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), vbox6, TRUE, TRUE, 0);

  label29 = gtk_label_new (_("Entrez une valeur :"));
  gtk_widget_ref (label29);
  gtk_object_set_data_full (GTK_OBJECT (EdWin), "label29", label29,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label29);
  gtk_box_pack_start (GTK_BOX (vbox6), label29, FALSE, FALSE, 0);

  EntryEdit = gtk_entry_new ();
  gtk_widget_ref (EntryEdit);
  gtk_object_set_data_full (GTK_OBJECT (EdWin), "EntryEdit", EntryEdit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EntryEdit);
  gtk_box_pack_start (GTK_BOX (vbox6), EntryEdit, FALSE, FALSE, 0);

  dialog_action_area2 = GNOME_DIALOG (EdWin)->action_area;
  gtk_object_set_data (GTK_OBJECT (EdWin), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area2), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area2), 8);

  gnome_dialog_append_button (GNOME_DIALOG (EdWin), GNOME_STOCK_BUTTON_OK);
  ButEditOk = g_list_last (GNOME_DIALOG (EdWin)->buttons)->data;
  gtk_widget_ref (ButEditOk);
  gtk_object_set_data_full (GTK_OBJECT (EdWin), "ButEditOk", ButEditOk,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButEditOk);
  GTK_WIDGET_SET_FLAGS (ButEditOk, GTK_CAN_DEFAULT);
  gtk_widget_add_accelerator (ButEditOk, "clicked", accel_group,
                              GDK_Return, 0,
                              GTK_ACCEL_VISIBLE);

  gnome_dialog_append_button (GNOME_DIALOG (EdWin), GNOME_STOCK_BUTTON_CANCEL);
  ButEditCancel = g_list_last (GNOME_DIALOG (EdWin)->buttons)->data;
  gtk_widget_ref (ButEditCancel);
  gtk_object_set_data_full (GTK_OBJECT (EdWin), "ButEditCancel", ButEditCancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButEditCancel);
  GTK_WIDGET_SET_FLAGS (ButEditCancel, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (EntryEdit), "changed",
                      GTK_SIGNAL_FUNC (on_EntryEdit_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ButEditOk), "clicked",
                      GTK_SIGNAL_FUNC (on_ButEditOk_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ButEditCancel), "clicked",
                      GTK_SIGNAL_FUNC (on_ButEditCancel_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdWin), "key_press_event",
                      GTK_SIGNAL_FUNC (on_EditWin_key_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EdWin), "close",
                      GTK_SIGNAL_FUNC (on_EditWin_close),
                      NULL);

  gtk_window_add_accel_group (GTK_WINDOW (EdWin), accel_group);

  return EdWin;
}

GtkWidget*
create_about1 (void)
{
  const gchar *authors[] = {
    "Laurent LOPES",
    NULL
  };
  GtkWidget *AboutWin;

  AboutWin = gnome_about_new ("GModbusControl", VERSION,
                        _("(c) 2001 Laurent LOPES"),
                        authors,
                        _("Controle d'une communication Modbus\nE-mail :  pes@free.fr"),
                        NULL);
  gtk_object_set_data (GTK_OBJECT (AboutWin), "AboutWin", AboutWin);
  gtk_window_set_modal (GTK_WINDOW (AboutWin), TRUE);

  gtk_signal_connect (GTK_OBJECT (AboutWin), "clicked",
                      GTK_SIGNAL_FUNC (on_about1_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (AboutWin), "close",
                      GTK_SIGNAL_FUNC (on_about1_clicked),
                      NULL);

  return AboutWin;
}

GtkWidget*
create_MessageWin (char *msg)
{
  GtkWidget *MsgWin;
  GtkWidget *dialog_vbox3;
  GtkWidget *ButInfoOk;
  GtkWidget *dialog_action_area3;

  MsgWin = gnome_message_box_new (msg,
                              GNOME_MESSAGE_BOX_ERROR, NULL);
  gtk_object_set_data (GTK_OBJECT (MsgWin), "MsgWin", MsgWin);
  gtk_window_set_title (GTK_WINDOW (MsgWin), _("Erreur"));
  gtk_window_set_policy (GTK_WINDOW (MsgWin), FALSE, FALSE, FALSE);

  dialog_vbox3 = GNOME_DIALOG (MsgWin)->vbox;
  gtk_object_set_data (GTK_OBJECT (MsgWin), "dialog_vbox3", dialog_vbox3);
  gtk_widget_show (dialog_vbox3);

  gnome_dialog_append_button (GNOME_DIALOG (MsgWin), GNOME_STOCK_BUTTON_OK);
  ButInfoOk = g_list_last (GNOME_DIALOG (MsgWin)->buttons)->data;
  gtk_widget_ref (ButInfoOk);
  gtk_object_set_data_full (GTK_OBJECT (MsgWin), "ButInfoOk", ButInfoOk,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButInfoOk);
  GTK_WIDGET_SET_FLAGS (ButInfoOk, GTK_CAN_DEFAULT);

  dialog_action_area3 = GNOME_DIALOG (MsgWin)->action_area;
  gtk_widget_ref (dialog_action_area3);
  gtk_object_set_data_full (GTK_OBJECT (MsgWin), "dialog_action_area3", dialog_action_area3,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_signal_connect (GTK_OBJECT (ButInfoOk), "clicked",
                      GTK_SIGNAL_FUNC (on_ButInfoOk_clicked),
                      NULL);

  return MsgWin;
}

/******************************************************************************************/
GtkWidget*
create_ConfigPort (void)
{
  GtkWidget *ConfigWin;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *hbox1;
  GtkWidget *label1;
  GtkWidget *OptionDevice;
  GtkWidget *OptionDevice_menu;
  GtkWidget *glade_menuitem0;
  GtkWidget *glade_menuitem1;
  GtkWidget *glade_menuitem2;
  GtkWidget *glade_menuitem3;
  GtkWidget *hbox2;
  GtkWidget *label2;
  GtkWidget *combo1;
  GList *combo1_items = NULL;
  GtkWidget *EntrySpeed;
  GtkWidget *hbox3;
  GtkWidget *label3;
  GSList *hbox3_group = NULL;
  GtkWidget *RadioBit7;
  GtkWidget *RadioBit8;
  GtkWidget *hbox5;
  GtkWidget *label5;
  GSList *hbox5_group = NULL;
  GtkWidget *RadioStop1;
  GtkWidget *RadioStop2;
  GtkWidget *hbox6;
  GtkWidget *label32;
  GSList *hbox6_group = NULL;
  GtkWidget *RadioParNone;
  GtkWidget *RadioParPaire;
  GtkWidget *RadioParImpaire;
  GtkWidget *hbox16;
  GtkWidget *label30;
  GtkObject *SpinTimeout_adj;
  GtkWidget *SpinTimeout;
  GtkWidget *label31;
  GtkWidget *dialog_action_area1;
  GtkWidget *ButConfOk;
  GtkWidget *ButConfCancel;

  char *buf;
  buf = (char *) malloc(20*sizeof(char));  

  conftemp=confreal;
  
  ConfigWin = gnome_dialog_new (_("Configuration du port srie"), NULL);
  gtk_object_set_data (GTK_OBJECT (ConfigWin), "ConfigWin", ConfigWin);
  gtk_window_set_policy (GTK_WINDOW (ConfigWin), FALSE, FALSE, FALSE);

  dialog_vbox1 = GNOME_DIALOG (ConfigWin)->vbox;
  gtk_object_set_data (GTK_OBJECT (ConfigWin), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  vbox1 = gtk_vbox_new (FALSE, 4);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 5);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  label1 = gtk_label_new (_("Device"));
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox1), label1, FALSE, FALSE, 0);
  gtk_widget_set_usize (label1, 180, -2);

  OptionDevice = gtk_option_menu_new ();
  gtk_widget_ref (OptionDevice);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "OptionDevice", OptionDevice,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (OptionDevice);
  gtk_box_pack_start (GTK_BOX (hbox1), OptionDevice, FALSE, FALSE, 0);

  OptionDevice_menu = gtk_menu_new ();

  glade_menuitem0 = gtk_menu_item_new_with_label (_("/dev/ttyS0 (com1)"));
  gtk_widget_show (glade_menuitem0);
  gtk_menu_append (GTK_MENU (OptionDevice_menu), glade_menuitem0);
  gtk_signal_connect (GTK_OBJECT (glade_menuitem0), "activate",
                      GTK_SIGNAL_FUNC (on_OptionDevice_clicked),
                      "0");

  glade_menuitem1 = gtk_menu_item_new_with_label (_("/dev/ttyS1 (com2)"));
  gtk_widget_show (glade_menuitem1);
  gtk_menu_append (GTK_MENU (OptionDevice_menu), glade_menuitem1);
  gtk_signal_connect (GTK_OBJECT (glade_menuitem1), "activate",
                      GTK_SIGNAL_FUNC (on_OptionDevice_clicked),
                      "1");

  glade_menuitem2 = gtk_menu_item_new_with_label (_("/dev/ttyS2 (com3)"));
  gtk_widget_show (glade_menuitem2);
  gtk_menu_append (GTK_MENU (OptionDevice_menu), glade_menuitem2);
  gtk_signal_connect (GTK_OBJECT (glade_menuitem2), "activate",
                      GTK_SIGNAL_FUNC (on_OptionDevice_clicked),
                      "2");

  glade_menuitem3 = gtk_menu_item_new_with_label (_("/dev/ttyS3 (com4)"));
  gtk_widget_show (glade_menuitem3);
  gtk_menu_append (GTK_MENU (OptionDevice_menu), glade_menuitem3);
  gtk_signal_connect (GTK_OBJECT (glade_menuitem3), "activate",
                      GTK_SIGNAL_FUNC (on_OptionDevice_clicked),
                      "3");

  gtk_option_menu_set_menu (GTK_OPTION_MENU (OptionDevice), OptionDevice_menu);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, TRUE, TRUE, 0);

  label2 = gtk_label_new (_("Vitesse de transmission"));
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (hbox2), label2, FALSE, FALSE, 0);
  gtk_widget_set_usize (label2, 180, -2);

  combo1 = gtk_combo_new ();
  gtk_widget_ref (combo1);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "combo1", combo1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo1);
  gtk_box_pack_start (GTK_BOX (hbox2), combo1, FALSE, FALSE, 0);
  combo1_items = g_list_append (combo1_items, _("230400"));
  combo1_items = g_list_append (combo1_items, _("115200"));
  combo1_items = g_list_append (combo1_items, _("57600"));
  combo1_items = g_list_append (combo1_items, _("38400"));
  combo1_items = g_list_append (combo1_items, _("19200"));
  combo1_items = g_list_append (combo1_items, _("9600"));
  combo1_items = g_list_append (combo1_items, _("4800"));
  combo1_items = g_list_append (combo1_items, _("2400"));
  combo1_items = g_list_append (combo1_items, _("1800"));
  combo1_items = g_list_append (combo1_items, _("1200"));
  combo1_items = g_list_append (combo1_items, _("600"));
  combo1_items = g_list_append (combo1_items, _("300"));
  gtk_combo_set_popdown_strings (GTK_COMBO (combo1), combo1_items);
  g_list_free (combo1_items);

  EntrySpeed = GTK_COMBO (combo1)->entry;
  gtk_widget_ref (EntrySpeed);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "EntrySpeed", EntrySpeed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (EntrySpeed);
  gtk_entry_set_text (GTK_ENTRY (EntrySpeed), _("1200"));

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, TRUE, TRUE, 0);

  label3 = gtk_label_new (_("Nbre de  bits de donnes"));
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (hbox3), label3, FALSE, FALSE, 0);
  gtk_widget_set_usize (label3, 180, -2);

  RadioBit7 = gtk_radio_button_new_with_label (hbox3_group, _("7"));
  hbox3_group = gtk_radio_button_group (GTK_RADIO_BUTTON (RadioBit7));
  gtk_widget_ref (RadioBit7);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "RadioBit7", RadioBit7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RadioBit7);
  gtk_box_pack_start (GTK_BOX (hbox3), RadioBit7, FALSE, FALSE, 0);
  gtk_widget_set_usize (RadioBit7, 60, -2);

  RadioBit8 = gtk_radio_button_new_with_label (hbox3_group, _("8"));
  hbox3_group = gtk_radio_button_group (GTK_RADIO_BUTTON (RadioBit8));
  gtk_widget_ref (RadioBit8);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "RadioBit8", RadioBit8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RadioBit8);
  gtk_box_pack_start (GTK_BOX (hbox3), RadioBit8, FALSE, FALSE, 0);
  gtk_widget_set_usize (RadioBit8, 60, -2);

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox5);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "hbox5", hbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox5);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox5, TRUE, TRUE, 0);

  label5 = gtk_label_new (_("Nbre de  bits de stop"));
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_box_pack_start (GTK_BOX (hbox5), label5, FALSE, FALSE, 0);
  gtk_widget_set_usize (label5, 180, -2);

  RadioStop1 = gtk_radio_button_new_with_label (hbox5_group, _("1"));
  hbox5_group = gtk_radio_button_group (GTK_RADIO_BUTTON (RadioStop1));
  gtk_widget_ref (RadioStop1);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "RadioStop1", RadioStop1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RadioStop1);
  gtk_box_pack_start (GTK_BOX (hbox5), RadioStop1, FALSE, FALSE, 0);
  gtk_widget_set_usize (RadioStop1, 60, -2);

  RadioStop2 = gtk_radio_button_new_with_label (hbox5_group, _("2"));
  hbox5_group = gtk_radio_button_group (GTK_RADIO_BUTTON (RadioStop2));
  gtk_widget_ref (RadioStop2);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "RadioStop2", RadioStop2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RadioStop2);
  gtk_box_pack_start (GTK_BOX (hbox5), RadioStop2, FALSE, FALSE, 0);
  gtk_widget_set_usize (RadioStop2, 60, -2);

  hbox6 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox6);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "hbox6", hbox6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox6, TRUE, TRUE, 0);

  label32 = gtk_label_new (_("Parite"));
  gtk_widget_ref (label32);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "label32", label32,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label32);
  gtk_box_pack_start (GTK_BOX (hbox6), label32, FALSE, FALSE, 0);
  gtk_widget_set_usize (label32, 180, -2);

  RadioParNone = gtk_radio_button_new_with_label (hbox6_group, _("Aucune"));
  hbox6_group = gtk_radio_button_group (GTK_RADIO_BUTTON (RadioParNone));
  gtk_widget_ref (RadioParNone);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "RadioParNone", RadioParNone,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RadioParNone);
  gtk_box_pack_start (GTK_BOX (hbox6), RadioParNone, FALSE, FALSE, 0);
  gtk_widget_set_usize (RadioParNone, 60, -2);

  RadioParPaire = gtk_radio_button_new_with_label (hbox6_group, _("paire"));
  hbox6_group = gtk_radio_button_group (GTK_RADIO_BUTTON (RadioParPaire));
  gtk_widget_ref (RadioParPaire);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "RadioParPaire", RadioParPaire,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RadioParPaire);
  gtk_box_pack_start (GTK_BOX (hbox6), RadioParPaire, FALSE, FALSE, 0);
  gtk_widget_set_usize (RadioParPaire, 60, -2);

  RadioParImpaire = gtk_radio_button_new_with_label (hbox6_group, _("Impaire"));
  hbox6_group = gtk_radio_button_group (GTK_RADIO_BUTTON (RadioParImpaire));
  gtk_widget_ref (RadioParImpaire);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "RadioParImpaire", RadioParImpaire,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (RadioParImpaire);
  gtk_box_pack_start (GTK_BOX (hbox6), RadioParImpaire, FALSE, FALSE, 0);
  gtk_widget_set_usize (RadioParImpaire, 60, -2);

  hbox16 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox16);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "hbox16", hbox16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox16);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox16, TRUE, TRUE, 0);

  label30 = gtk_label_new (_("Time out"));
  gtk_widget_ref (label30);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "label30", label30,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label30);
  gtk_box_pack_start (GTK_BOX (hbox16), label30, FALSE, FALSE, 0);
  gtk_widget_set_usize (label30, 180, -2);

  SpinTimeout_adj = gtk_adjustment_new (conftemp.timeout, 10, 10000, 1, 10, 10);
  SpinTimeout = gtk_spin_button_new (GTK_ADJUSTMENT (SpinTimeout_adj), 1, 0);
  gtk_widget_ref (SpinTimeout);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "SpinTimeout", SpinTimeout,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (SpinTimeout);
  gtk_box_pack_start (GTK_BOX (hbox16), SpinTimeout, FALSE, FALSE, 0);
  gtk_widget_set_usize (SpinTimeout, 70, -2);

  label31 = gtk_label_new (_("ms"));
  gtk_widget_ref (label31);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "label31", label31,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label31);
  gtk_box_pack_start (GTK_BOX (hbox16), label31, FALSE, FALSE, 0);
  gtk_widget_set_usize (label31, 21, -2);

  dialog_action_area1 = GNOME_DIALOG (ConfigWin)->action_area;
  gtk_object_set_data (GTK_OBJECT (ConfigWin), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area1), 8);

  gnome_dialog_append_button (GNOME_DIALOG (ConfigWin), GNOME_STOCK_BUTTON_OK);
  ButConfOk = g_list_last (GNOME_DIALOG (ConfigWin)->buttons)->data;
  gtk_widget_ref (ButConfOk);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "ButConfOk", ButConfOk,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButConfOk);
  GTK_WIDGET_SET_FLAGS (ButConfOk, GTK_CAN_DEFAULT);

  gnome_dialog_append_button (GNOME_DIALOG (ConfigWin), GNOME_STOCK_BUTTON_CANCEL);
  ButConfCancel = g_list_last (GNOME_DIALOG (ConfigWin)->buttons)->data;
  gtk_widget_ref (ButConfCancel);
  gtk_object_set_data_full (GTK_OBJECT (ConfigWin), "ButConfCancel", ButConfCancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (ButConfCancel);
  GTK_WIDGET_SET_FLAGS (ButConfCancel, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (OptionDevice), "clicked",
                      GTK_SIGNAL_FUNC (on_OptionDevice_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (EntrySpeed), "changed",
                      GTK_SIGNAL_FUNC (on_EntrySpeed_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (RadioBit7), "toggled",
                      GTK_SIGNAL_FUNC (on_RadioBit7_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (RadioBit8), "toggled",
                      GTK_SIGNAL_FUNC (on_RadioBit8_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (RadioStop1), "toggled",
                      GTK_SIGNAL_FUNC (on_RadioStop1_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (RadioStop2), "toggled",
                      GTK_SIGNAL_FUNC (on_RadioStop2_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (RadioParNone), "toggled",
                      GTK_SIGNAL_FUNC (on_RadioParNone_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (RadioParPaire), "toggled",
                      GTK_SIGNAL_FUNC (on_RadioParPaire_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (RadioParImpaire), "toggled",
                      GTK_SIGNAL_FUNC (on_RadioParImpaire_toggled),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (SpinTimeout), "changed",
                      GTK_SIGNAL_FUNC (on_SpinTimeout_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ButConfOk), "clicked",
                      GTK_SIGNAL_FUNC (on_ButConfOk_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ButConfCancel), "clicked",
                      GTK_SIGNAL_FUNC (on_ButConfCancel_clicked),
                      NULL);

  if (conftemp.databit==8)
     gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (RadioBit8), TRUE);
  else
     gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (RadioBit7), TRUE);

  if (conftemp.stop==1)
     gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (RadioStop1), TRUE);
  else
     gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (RadioStop2), TRUE);

  if (conftemp.parity==0)
     gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (RadioParNone), TRUE);
  if (conftemp.parity==1)
     gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (RadioParPaire), TRUE);
  if (conftemp.parity==-1)
     gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (RadioParImpaire), TRUE);

  g_snprintf(buf,10,"%d",conftemp.speed);
  gtk_entry_set_text(GTK_ENTRY(EntrySpeed),buf);

  if (conftemp.port[9]=='0')
     gtk_option_menu_set_history(GTK_OPTION_MENU(OptionDevice),0);
  if (conftemp.port[9]=='1')
     gtk_option_menu_set_history(GTK_OPTION_MENU(OptionDevice),1);
  if (conftemp.port[9]=='2')
     gtk_option_menu_set_history(GTK_OPTION_MENU(OptionDevice),2);
  if (conftemp.port[9]=='3')
     gtk_option_menu_set_history(GTK_OPTION_MENU(OptionDevice),3);
   

  return ConfigWin;
}

