#include "main.h"
#include "interface.h"
#include <pthread.h>

#define MODBUSDATASIZE	100


/************************************************************************************/
void readed(unsigned char c)
{
   if (Text_HoD==1 && c<0x10)
      TrameRcve=g_strdup_printf("%s 0x0%x ",TrameRcve,c);
   if (Text_HoD==1 && c>=0x10)
      TrameRcve=g_strdup_printf("%s 0x%x ",TrameRcve,c);
   if (Text_HoD==0)
      TrameRcve=g_strdup_printf("%s %d ",TrameRcve,c);

}

/************************************************************************************/
void writed(unsigned char c)
{
   if (Text_HoD==1 && c<0x10)
      TrameEmit=g_strdup_printf("%s 0x0%x ",TrameEmit,c);
   if (Text_HoD==1 && c>=0x10)
      TrameEmit=g_strdup_printf("%s 0x%x ",TrameEmit,c);
   if (Text_HoD==0)
      TrameEmit=g_strdup_printf("%s %d ",TrameEmit,c);

}

/************************************************************************************/
void end_slave(int fonction, int adresse, int longueur)
{
   char *buf;
   int i;
   gtk_text_insert (GTK_TEXT (TextConsole), NULL, NULL, NULL,TrameRcve, -1);
   gtk_text_insert (GTK_TEXT (TextConsole), NULL, NULL, NULL,"\n", -1);
   gtk_text_insert (GTK_TEXT (TextConsole), NULL, NULL, NULL,TrameEmit, -1);
   gtk_text_insert (GTK_TEXT (TextConsole), NULL, NULL, NULL,"\n", -1);
   gtk_text_insert (GTK_TEXT (TextConsole), NULL, NULL, NULL,"\n", -1);
/*   g_print("%s",TrameRcve);
   g_print("\n");
   g_print("%s",TrameEmit);
   g_print("\n");
   g_print("\n");*/
   TrameRcve=g_strdup_printf("(Slave) Recv <-");
   TrameEmit=g_strdup_printf("(Slave) Send ->");

/*   g_print("end slave adresse : %d, longueur %d\n\n",adresse,longueur);*/
   if (fonction==-1)
   {
      gtk_statusbar_push( GTK_STATUSBAR(statusbar1),Statusbar_context_id,"receptrion d'une trame, erreur de crc ");
      return;
   }
   if (fonction==0x6 || fonction==0x10)
   {
      gtk_clist_freeze(GTK_CLIST(ClistSlave));
      for(i=0;i<longueur;i++)
      {
         buf=g_strdup_printf("%d \t0x%x",Mbs_data[adresse+i],Mbs_data[adresse+i]);
         gtk_clist_set_text(GTK_CLIST(ClistSlave),i+adresse,1,buf);
      }
      gtk_clist_thaw(GTK_CLIST(ClistSlave));
   }
   gtk_statusbar_push( GTK_STATUSBAR(statusbar1),Statusbar_context_id,"receptrion d'une trame ok ");

}

/************************************************************************************/
interf_init()
{
   int i;
   gchar *buf[3];
   
   MainWin = create_MainWin ();
   gtk_widget_show (MainWin);

   gtk_clist_freeze(GTK_CLIST(ClistMaster));
   gtk_clist_freeze(GTK_CLIST(ClistSlave));
   
   /* init interface */
   for(i=0;i<=255;i++)
   {
      buf[0]=g_strdup_printf("%d \t0x%x",i,i);
      buf[1]=g_strdup_printf("0 \t0x0");
      buf[2]=g_strdup_printf("0 \t0x0");
      gtk_clist_append(GTK_CLIST(ClistMaster), buf);
   }
   for(i=0;i<MODBUSDATASIZE;i++)
   {
      buf[0]=g_strdup_printf("%d \t0x%x",i,i);
      buf[1]=g_strdup_printf("0 \t0x0");
      gtk_clist_append(GTK_CLIST(ClistSlave), buf);

      Mbs_data[i]=0;
   }
   
   gtk_clist_thaw(GTK_CLIST(ClistMaster));
   gtk_clist_thaw(GTK_CLIST(ClistSlave));
   ClistMasterRow=-1;
   ClistSlaveRow=-1;

   gtk_statusbar_push( GTK_STATUSBAR(statusbar1),Statusbar_context_id,"G Modbus Control pret.");

}

/************************************************************************************/
app_init()
{
   FILE *fd;
   char *fichier;
   char str[100];
   int l;
   
   fichier=getenv("HOME");
   strcat (fichier,"/.gmbc");

   if ((fd=fopen(fichier,"rt"))==NULL)
   {
      /* pas de fichiers de configuaration*/
      /* init modbus master */
      trame.function=3;
      trame.slave=1;
      trame.address=0;
      trame.length=1;

      /* init modbus slave */
      Slave=1;

      /* init console */
      Text_HoD=1;			/* print console in hexa mode */

      /* init modbus comm */
      confreal.port=g_strdup_printf("/dev/ttyS0");
      confreal.speed=9600;
      confreal.databit=8;
      confreal.stop=1;
      confreal.parity=0;
      confreal.timeout=1000;
   }
   else
   {
  	   fscanf(fd,"%s",str);trame.function=atoi(str);
      fscanf(fd,"%s",str);trame.slave=atoi(str);
      fscanf(fd,"%s",str);trame.address=atoi(str);
      fscanf(fd,"%s",str);trame.length=atoi(str);

      fscanf(fd,"%s",str);Slave=atoi(str);

      fscanf(fd,"%s",str);Text_HoD=atoi(str);

      fscanf(fd,"%s",str);
      l=strlen(str);
      str[l]=0;
      confreal.port=g_strdup_printf(str);
      fscanf(fd,"%s",str);confreal.speed=atoi(str);
      fscanf(fd,"%s",str);confreal.databit=atoi(str);
      fscanf(fd,"%s",str);confreal.stop=atoi(str);
      fscanf(fd,"%s",str);confreal.parity=atoi(str);
      fscanf(fd,"%s",str);confreal.timeout=atoi(str);
      fclose(fd);
   }
   SlaveIsRunning=0;

/*   Mb_verbose=1;*/

   /* initilasiation du port de communication*/
   gmbdev=Mb_open_device(confreal.port,confreal.speed,confreal.parity,confreal.databit,confreal.stop);

   /* allocation de memoire pour la table modbus en fonctionnement escalve */
   Mbs_data = (int *) malloc(MODBUSDATASIZE*sizeof(int));
}

/************************************************************************************/
void app_close()
{
   FILE *fd;
   char *fichier;
   char str[100];

   Mb_close_device(gmbdev);
   free(Mbs_data);

   fichier=g_strdup_printf(getenv("HOME"),"/.gmbc");

   if ((fd=fopen(fichier,"wt"))==NULL)
   {
      printf("Le fichier %s  ne peut pas etre ouvert.\n",fichier);
   }
   else
   {
      
      fprintf(fd,"%d\n",trame.function);
      fprintf(fd,"%d\n",trame.slave);
      fprintf(fd,"%d\n",trame.address);
      fprintf(fd,"%d\n",trame.length);

      fprintf(fd,"%d\n",Slave);

      fprintf(fd,"%d\n",Text_HoD);

      fprintf(fd,"%s\n",confreal.port);
      fprintf(fd,"%d\n",confreal.speed);
      fprintf(fd,"%d\n",confreal.databit);
      fprintf(fd,"%d\n",confreal.stop);
      fprintf(fd,"%d\n",confreal.parity);
      fprintf(fd,"%d\n",confreal.timeout);
      fclose(fd);
   }
}

/************************************************************************************/
int main (int argc, char *argv[])
{

   /* initialisation de gnome */
  gnome_init ("gmodbuscontrol", VERSION, argc, argv);
  
  /* obligatoire pour l'utlisation de la librairie thread ave la libg */
  g_thread_init(NULL);

  /*printf("version de la librairie modbus %s\n",Mb_version());*/
  
  app_init();
  interf_init();
  gtk_main ();
  app_close();
  return 0;
}

